function q = bodg(p,R)
%BODG     Supporting file for bod.m; ATTENTION: calling by bod.m only
%         q = bodg(p,R)
% necessary for the application of the Discontinuous Magnitude Optimum (BOD) to
% discontinuous controllers of PID-type family in case of delayed input signals;
% preparation of fsolve, definition: p=[x=V0 y=V0*d1 z=V0*d2]

% KEY WORDS: supporting file

%  Copyright (c) 1997-2023. All Rights Reserved. 
%                     Dr. Gert-Helge Geitner, TU Dresden,
%  Reference regarding Discontinuous Magnitude Optimum: Geitner, G.-H.:
%                     Entwurf digitaler Regler fr elektrische Antriebe.
%                     publisher: VDE-Verlag GmbH Berlin und Offenbach 1996
%                     ISBN 3-8007-1847-2

x = p(1); y = p(2); z = p(3);
q = zeros(3,1);
q(1)=R(1,1)+x*R(1,2)+y*R(1,3)+z*R(1,4)+y*(x+z)*(R(1,6)-R(1,5))...
                                      +x*z*(R(1,7)-R(1,5));
q(2)=R(2,1)+x*R(2,2)+y*R(2,3)+z*R(2,4)+y*(x+z)*(R(2,6)-R(2,5))...
                                      +x*z*(R(2,7)-R(2,5));
q(3)=R(3,1)+x*R(3,2)+y*R(3,3)+z*R(3,4)+y*(x+z)*(R(3,6)-R(3,5))...
                                      +x*z*(R(3,7)-R(3,5));
